/*
 *  $Id: z80.h,v 1.1.1.1 1998/01/11 00:00:37 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of KCemu, the KC 85/4 Emulator.
 */

#ifndef __kc_z80_h
#define __kc_z80_h

/*
 *  we include a patched version of the Z80-core include file
 *  due to name conflicts...
 *  it uses a 'struct Z80' that clashes with the 'class Z80'
 *  we want define here.
 *
 *  'struct Z80' ist changed to 'struct _Z80'
 */
#include "kc/kc.h"

extern "C" {
#include "core/Z80.h"
}

class Z80
{
  private:
    _Z80 regs;
  public:
    bool _do_quit;
    bool _do_reset;
    bool _do_power_on;

    Z80(void);
    void run(void);
    void quit(void);
    void reset(void);
    void powerOn(void);
    void trace(byte_t level);
    void triggerInt(int vector);
};

#endif /* __kc_z80_h */
