/*
 *  $Id: kc.cc,v 1.1.1.1 1998/01/11 00:00:37 tp Exp $
 *
 *
 *  Copyright (C) 1997 Torsten Paul
 *
 *  This file is part of KCemu, the KC 85/4 Emulator.
 */

#include <iostream.h>

#include "kc/kc.h"
#include "kc/z80.h"
#include "kc/ctc.h"
#include "kc/ports.h"
#include "kc/memory.h"

#ifdef MSDOS
#include "ui/ui_dos.h"
#endif
#ifdef LINUX
#include "ui/ui_xwin.h"
#endif

Z80      *z80;
UI       *ui;
Ports    *ports;
Memory   *memory;
CTC      *ctc;

int main(int argc, char **argv)
{
	z80      = new Z80;
	memory   = new Memory;
#ifdef MSDOS
	ui       = new UI_DOS(&argc, &argv);
#endif
#ifdef LINUX
	ui	 = new UI_XWin;
#endif
	ports    = new Ports;
	ctc      = new CTC;

	z80->run();

	delete ctc;
	delete memory;
	delete ports;
	delete ui;
	delete z80;

	cout << endl
#ifdef MSDOS
	     << "*** KCemu V0.01 for DOS (built on " __DATE__ ") ***" << endl
#endif /* MSDOS */
#ifdef LINUX
	     << "*** KCemu V0.01 for Linux (built on " __DATE__ ") ***" << endl
#endif /* LINUX */
	     << endl
	     << "Copyright (C) 1997 Torsten Paul" << endl
	     << endl
	     << "KCemu comes with ABSOLUTELY NO WARRANTY." << endl
	     << "This is free software, and you are welcome to redistribute it" << endl
	     << "under certain conditions; see the file 'COPYING' for details." << endl
	     << endl
	     << "Thanks go to:" << endl
	     << endl
	     << "\t* Marat Fayzullin for his portable Z80 processor emulation" << endl
#ifdef MSDOS
	     << "\t* Shawn Hargreaves for Allegro, the game programming library" << endl
	     << "\t* Tran (a.k.a. Thomas Pytel) and Matthias Grimrath for" << endl
	     << "\t  PMODE 3.07, PMODE/DJ" << endl
	     << "\t* DJ Delorie for the DJGPP 2.01 compiler and programming environment" << endl
#endif /* MSDOS */
	     << endl
	     << "\tand" << endl
	     << endl
	     << "\t* Frank Klemm for his great Boulder Dash :-)" << endl
	     << endl;

	return 0;
}
